package com.jcg.section5;

import java.io.File;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.concurrent.Callable;

/**
 * @author #hashtagmercury
 */
public class SearchOperation implements Callable
{
     File fileToSearch;
     String searchString;
     
    public SearchOperation(File fileName, String searchString){
      this.fileToSearch = fileName;
      this.searchString = searchString;
    }

    @Override
    public SearchResult call() throws Exception {
        System.out.println("inside call : " + fileToSearch);
        String content = new String(Files.readAllBytes(fileToSearch.toPath()));
        SearchResult result = new SearchResult();
        result.setFileName(fileToSearch.getAbsolutePath());
        if (content.contains(searchString)) {
            result.setIsFound(true);
        } else {
            result.setIsFound(false);
        }
        
        return result;
    }
}
