package com.jcg.section5;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;
import static java.util.Spliterators.iterator;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

/**
 * @author #hashtagmercury
 */
public class SearchTextExample {
    
    public static void main(String[] args){
        try{
        SearchTextExample app = new SearchTextExample();
        app.executeSearch();
        } catch (Exception ex){
            ex.printStackTrace();
        }
    }
    
    public void executeSearch() throws Exception 
    {
        String searchKey = "monster";
        File searchFolder = new File("testdata");
        
        if(searchFolder.isDirectory()){
            System.out.println("this is a directory" + searchFolder.getAbsolutePath());
        }
        
        File[] files = searchFolder.listFiles();
        List<Future> taskResultList = new ArrayList<>();
        
        ExecutorService executorService = Executors.newFixedThreadPool(3);
        for(int i=0; i< files.length; i++) {
            System.out.println("File : "+ files[i].getAbsolutePath());
            taskResultList.add(executorService.submit(new SearchOperation(files[i],searchKey)));
                    
        }
        
        TimeUnit.SECONDS.sleep(5);
        //Iterate Futures
        ListIterator<Future> iterator = taskResultList.listIterator();
        while(iterator.hasNext()){
            Future<SearchResult> futureElement = iterator.next();
            if(futureElement.isDone()){
                System.out.println("Future element is done");
                System.out.println(futureElement.get());
            } else {
                System.out.println("Future element is not done");
            }
            
        executorService.shutdown();
        
    }
 
}
}