package com.jcg.section6;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.FutureTask;

/**
 * @author #hashtagmercury
 */
//FutureTask wraps a callable. Here Callable is a Method local inner class
public class FutureTaskExample1 {
    
    public static void main(String[] args){
        FutureTaskExample1 app = new FutureTaskExample1();
        app.demo();
   }
    
   public void demo(){
    
       //Method local inner class
       class DemoCallable implements Callable{
        
        @Override
        public Integer call() throws Exception {
            System.out.println("call() execution " + Thread.currentThread().getName());
            return 0;
        }
    }
     
       //execution code for demo method
       System.out.println("demo() execution " + Thread.currentThread().getName());
       ExecutorService executor = Executors.newSingleThreadExecutor();
       FutureTask<?> futureTask = new FutureTask<Integer>(new DemoCallable());
       executor.execute(futureTask);
       executor.shutdown();
   }
    
}
