package com.jcg.section6;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.FutureTask;

/**
 * @author #hashtagmercury
 */
//FutureTask wraps a callable. Here Callable is a Method local inner class
//Example to submit a future task as a standalone
public class FutureTaskExample2 {
    
    public static void main(String[] args){
        FutureTaskExample2 app = new FutureTaskExample2();
        app.demo();
   }
    
   public void demo(){
    
       //Method local inner class
       class DemoCallable implements Callable{
        
        @Override
        public Integer call() throws Exception {
            System.out.println("call() execution " + Thread.currentThread().getName());
            return 0;
        }
    }
     
       //execution code for demo method
       System.out.println("demo() execution " + Thread.currentThread().getName());
       
       FutureTask<?> futureTask = new FutureTask<Integer>(new DemoCallable());
       new Thread(futureTask).start();
   }
    
}
