package com.jcg.section6;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.FutureTask;

/**
 * @author #hashtagmercury
 */
//FutureTask wraps a Runnable. Here Runnable is a Method local inner class
public class FutureTaskExample3 {
    
    public static void main(String[] args){
        FutureTaskExample3 app = new FutureTaskExample3();
       try{
        app.demo();
       } catch (Exception ex){
           ex.printStackTrace();
       }
   }
    
   public void demo() throws Exception
   {
      //Method local inner class
       class DemoRunnable implements Runnable{
        
        @Override
        public void run() {
            System.out.println("run() execution " + Thread.currentThread().getName());
            
        }
    }
     
       //execution code for demo method
       System.out.println("demo() execution " + Thread.currentThread().getName());
       ExecutorService executor = Executors.newSingleThreadExecutor();
       FutureTask<String> futureTask = new FutureTask<>(new DemoRunnable(),"Complete Message");
       executor.execute(futureTask);
       System.out.println(futureTask.get());
       executor.shutdown();
   }
    
}
