package com.jcg.section7;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

/**
 * @author #hashtagmercury
 */
public class CompletableExample4 {

    public static void main(String[] args){
        
        CompletableExample4 app = new CompletableExample4();
        try {
        app.test();
        } catch(Exception ex){
            ex.printStackTrace();
        }
    }
    
    private void test() throws Exception
    {
        ExecutorService execService = Executors.newSingleThreadExecutor();
        
        //#Phase1
        CompletableFuture<String> cf1 = CompletableFuture.supplyAsync(new SampleSupplier(), execService);
        //#Phase2
        CompletableFuture<Void> cf2 = cf1.thenAcceptAsync(this::postProcess, execService);
        //#Phase3
        cf2.thenRun(() -> {
           System.out.println("Last phase of computation " + Thread.currentThread().getName());
        });
        while (!cf2.isDone()) {
            TimeUnit.SECONDS.sleep(2);
            if (cf2.isDone()){
                execService.shutdown();
            }
        }
    }
    
    public void postProcess(Object result){
        System.out.println("Result is " + result + " / " + Thread.currentThread().getName());
    }
}
